SystemOrganization addCategory: #'JQWidgetBox-ShadowAnimation-Dev-Examples'!
SystemOrganization addCategory: #'JQWidgetBox-ShadowAnimation-Dev-Tests'!

JQWidgetBoxWidgetTest subclass: #JQShadowAnimationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-ShadowAnimation-Dev-Tests'!

!JQShadowAnimationTest methodsFor: 'accessing' stamp: 'tbn 2/15/2011 19:45'!
animate
	^ self target animate! !

!JQShadowAnimationTest methodsFor: 'accessing' stamp: 'tbn 2/15/2011 19:45'!
target
	^ self jQuery: 'div'! !

!JQShadowAnimationTest methodsFor: 'accessing' stamp: 'tbn 2/15/2011 19:48'!
testAnimateParams
	self
		assert: (self animate boxShadow: '0 0 50px')
		equals: self function , '("div").animate({"boxShadow":"0 0 50px"},{})'.
! !

JQWidgetExample subclass: #JQShadowAnimationExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-ShadowAnimation-Dev-Examples'!

!JQShadowAnimationExample classSide methodsFor: 'accessing' stamp: 'tbn 2/15/2011 18:44'!
description
	^ 'JQuery Shadow Animation'! !

!JQShadowAnimationExample classSide methodsFor: 'accessing' stamp: 'tbn 2/15/2011 19:17'!
shortName
	^'shadowAnimation'! !

!JQShadowAnimationExample methodsFor: 'updating' stamp: 'tbn 2/15/2011 19:32'!
renderContentOn: html
	html html: '
	<div id="box1" onmouseover="$(''#box1'').stop().animate({boxShadow: ''0 0 30px #44f''})" onmouseout="$(''#box1'').stop().animate({boxShadow: ''0 0 10px #000''})">mouse over</div>

<div id="box2" onmouseover="$(''#box2'').stop().animate({boxShadow: ''0 0 50px''}, ''fast'')" onmouseout="$(''#box2'').stop().animate({boxShadow: ''0 0 0''}, ''fast'')">mouse over</div>

	<div id="box3" onmousedown="$(''#box3'').stop().animate({boxShadow: ''3px 3px 3px'', top: 3}, ''fast'')" onmouseup="$(''#box3'').stop().animate({boxShadow: ''10px 10px 15px'', top: 0}, ''fast'')">click me</div>



	'  ! !

!JQShadowAnimationExample methodsFor: 'updating' stamp: 'tbn 2/15/2011 19:30'!
style
	^'
	#box1, #box2, #box3 {
	float: left;
	margin: 0 0 30px 50px;
	width: 100px;
	height: 50px;
	border-radius: 10px;
	-moz-border-radius: 10px;
	-webkit-border-radius: 10px;
	line-height: 45px;
	text-align: center;
	border: 3px solid #a9a9a9;
}

#box1 {
	box-shadow: 0 0 10px #000000;
	-moz-box-shadow: 0 0 10px #000000;
	-webkit-box-shadow: 0 0 10px #000000;
}

#box2 {
	box-shadow: inset 0 0 0 #f80;
	-moz-box-shadow: inset 0 0 0 #f80;
	-webkit-box-shadow: inset 0 0 0 #f80;
}

#box3 {
	position: relative;
	box-shadow: 8px 8px 15px #666;
	-moz-box-shadow: 8px 8px 15px #666;
	-webkit-box-shadow: 8px 8px 15px #666;
}

h2 {
	clear: both;
}
	
	
	'! !

!JQShadowAnimationExample methodsFor: 'updating' stamp: 'tbn 2/15/2011 18:43'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: self library / #jqueryanimateshadowminJs.

	! !

!JQWidgetBoxDevelopmentLibrary methodsFor: '*jqwidgetbox-shadowanimation-dev' stamp: 'tbn 2/15/2011 18:35'!
jqueryanimateshadowJs
	^ '/*!!
 * Shadow animation jQuery-plugin 1.5
 * http://www.bitstorm.org/jquery/shadow-animation/
 * Copyright 2011 Edwin Martin <edwin@bitstorm.org>
 * Contributors: Mark Carver, Xavier Lepretre
 * Released under the MIT and GPL licenses.
 */

jQuery(function($, undefined) {
	/**
	 * Check whether the browser supports RGBA color mode.
	 *
	 * Author Mehdi Kabab <http://pioupioum.fr>
	 * @return {boolean} True if the browser support RGBA. False otherwise.
	 */
	function isRGBACapable() {
		var $script = $(''script:first''),
				color = $script.css(''color''),
				result = false;
		if (/^rgba/.test(color)) {
			result = true;
		} else {
			try {
				result = ( color !!= $script.css(''color'', ''rgba(0, 0, 0, 0.5)'').css(''color'') );
				$script.css(''color'', color);
			} catch (e) {
			}
		}

		return result;
	}

	$.extend(true, $, {
		support: {
			''rgba'': isRGBACapable()
		}
	});

	/*************************************/

	// First define which property to use
	var boxShadowProperty;
	$.each([''boxShadow'', ''MozBoxShadow'', ''WebkitBoxShadow''], function(i, property) {
		var val = $(''html'').css(property);
		if (typeof val == ''string'' && val !!= '''') {
			boxShadowProperty = property;
			return false;
		}
	});

	// Extend the animate-function
	if (boxShadowProperty) {
		$.fx.step[''boxShadow''] = function(fx) {
			if (!!fx.init) {
				fx.begin = parseShadow($(fx.elem).css(boxShadowProperty));
				fx.end = $.extend({}, fx.begin, parseShadow(fx.options.curAnim[''boxShadow'']));
				if (fx.begin.color == undefined) {
					fx.begin.color = fx.end.color || [0, 0, 0];
				}
				fx.init = true;
			}
			fx.elem.style[boxShadowProperty] = calculateShadow(fx.begin, fx.end, fx.pos);
		}
	}

	// Calculate an in-between shadow.
	function calculateShadow(begin, end, pos) {
		var parts = [];
		if (begin.inset) {
			parts.push(''inset'');
		}
		if (typeof end.left !!= ''undefined'') {
			parts.push(parseInt(begin.left + pos * (end.left - begin.left), 10) + ''px ''
					+ parseInt(begin.top + pos * (end.top - begin.top), 10) + ''px'');
		}
		if (typeof end.blur !!= ''undefined'') {
			parts.push(parseInt(begin.blur + pos * (end.blur - begin.blur), 10) + ''px'');
		}
		if (typeof end.spread !!= ''undefined'') {
			parts.push(parseInt(begin.spread + pos * (end.spread - begin.spread), 10) + ''px'');
		}
		if (typeof end.color !!= ''undefined'') {
			var color = ''rgb'' + ($.support[''rgba''] ? ''a'' : '''') + ''(''
					+ parseInt((begin.color[0] + pos * (end.color[0] - begin.color[0])), 10) + '',''
					+ parseInt((begin.color[1] + pos * (end.color[1] - begin.color[1])), 10) + '',''
					+ parseInt((begin.color[2] + pos * (end.color[2] - begin.color[2])), 10);
			if ($.support[''rgba'']) {
				color += '','' + parseFloat(begin.color[3] + pos * (end.color[3] - begin.color[3]));
			}
			color += '')'';
			parts.push(color);
		}
		return parts.join('' '');
	}

	// Parse the shadow value and extract the values.
	function parseShadow(shadow) {
		var match, color, parsedShadow = {};

		// Parse an CSS-syntax color. Outputs an array [r, g, b]
		// Match #aabbcc
		if (match = /#([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})/.exec(shadow)) {
			color = [parseInt(match[1], 16), parseInt(match[2], 16), parseInt(match[3], 16), 1];

			// Match #abc
		} else if (match = /#([0-9a-fA-F])([0-9a-fA-F])([0-9a-fA-F])/.exec(shadow)) {
			color = [parseInt(match[1], 16) * 17, parseInt(match[2], 16) * 17, parseInt(match[3], 16) * 17, 1];

			// Match rgb(n, n, n)
		} else if (match = /rgb\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*\)/.exec(shadow)) {
			color = [parseInt(match[1], 10), parseInt(match[2], 10), parseInt(match[3], 10), 1];

			// Match rgba(n, n, n, n)
		} else if (match = /rgba\(\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([0-9]{1,3})\s*,\s*([01\.]*)\s*\)/.exec(shadow)) {
			color = [parseInt(match[1], 10), parseInt(match[2], 10), parseInt(match[3], 10),parseFloat(match[4])];

			// No browser returns rgb(n%, n%, n%), so little reason to support this format.
		}

		// Parse offset, blur and radius
		if (match = /(-?[0-9]+)(?:px)?\s+(-?[0-9]+)(?:px)?(?:\s+(-?[0-9]+)(?:px)?)?(?:\s+(-?[0-9]+)(?:px)?)?/.exec(shadow)) {
			parsedShadow = {left: parseInt(match[1], 10), top: parseInt(match[2], 10), blur: match[3] ? parseInt(match[3], 10) : 0, spread: match[4] ? parseInt(match[4], 10) : 0};
		} else {
			parsedShadow = {left: 0, top: 0, blur: 0, spread: 0};
		}

		// Inset or not
		parsedShadow.inset = /inset/.test(shadow);

		parsedShadow.color = color;

		return parsedShadow;
	}
});'! !
